//-----------------------------------------
// LScript Modeler template
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=1.3;
//1.3
// Fixed bug in the random rotation routine which led to all clones being rotated 1 degree.
//1.2
// Reduced lscript revision needed to 2.6 for compatability with 8.5.
//1.1
// fixed minor size bug.
@version 2.6
@warnings
@script modeler

// global values go here

st_pos=1;
st_dir=2;
st_size=3;

st_clone=1;
st_layer=2;
st_posit=3;
st_point=4;
st_scale=5;
st_scvar=6;
st_rotlx=7;
st_rotly=8;
st_rotlz=9;
st_pivot=10;
st_chanc=11;
st_scadj=12;
st_droop=13;
st_poslx=14;
st_posly=15;
st_poslz=16;
st_array=17;
st_copyx=18;
st_copyy=19;
st_copyz=20;
st_offsx=21;
st_offsy=22;
st_offsz=23;

SetUpMySet
{
    myset[st_clone] = 1;
    myset[st_layer] = 1;
    myset[st_posit] = 1;
    myset[st_point] = 1;
    myset[st_scale] = 1;
	myset[st_scadj] = 1;
    myset[st_scvar] = 0;
	myset[st_poslx] = 0;
	myset[st_posly] = 0;
	myset[st_poslz] = 0;
	myset[st_rotlx] = 0;
	myset[st_rotly] = 0;
	myset[st_rotlz] = 0;
	myset[st_pivot] = 1;
	myset[st_chanc] = 1;
	myset[st_droop] = 0;
	myset[st_array] = 1;
	myset[st_copyx] = 1;
	myset[st_copyy] = 1;
	myset[st_copyz] = 1;
	myset[st_offsx] = 1;
	myset[st_offsy] = 1;
	myset[st_offsz] = 1;
	return(myset);
}

main
{
	myset=SetUpMySet();
	for(i=1;i<=myset.size();i++)
	{
		myset[i]=recall("MGUltimateClone"+i.asStr(),myset[i]);
	}

    reqbegin("MGUltimateClone V:"+myversion);
	reqsize(380,450);
    c[st_clone] = ctlchoice("Clone to",myset[st_clone],@"FG","New Layer","Specified layer"@);
    c[st_layer] = ctlinteger("Layer",myset[st_layer]);
    c[st_posit] = ctlchoice("Position",myset[st_posit],@"Points","Polygons","Array","Circle"@);
    c[st_point] = ctlchoice("Point +Y at",myset[st_point],@"+X","+Y","+Z","-X","-Y","-Z","Normal"@);
    c[st_array] = ctlchoice("Offset as",myset[st_array],@"Percent","Distance"@);

    c[st_copyx] = ctlinteger("Copies X",myset[st_copyx]);
    c[st_copyy] = ctlinteger("Y",myset[st_copyy]);
    c[st_copyz] = ctlinteger("Z",myset[st_copyz]);
    ctlposition(c[st_copyx],15,125);
    ctlposition(c[st_copyy],154,125);
    ctlposition(c[st_copyz],260,125);

	t2 = ctltext("Below Value","If set to Array this is the clone offset, if set to Circle, this is the centre");
    ctlposition(t2,10,150);

    c[st_offsx] = ctlpercent("X",myset[st_offsx]);
    c[st_offsy] = ctlpercent("Y",myset[st_offsy]);
    c[st_offsz] = ctlpercent("Z",myset[st_offsz]);
    base=180;
	ctlposition(c[st_offsx],50,base);
    ctlposition(c[st_offsy],154,base);
    ctlposition(c[st_offsz],260,base);

    c[st_scale] = ctlchoice("Scale",myset[st_scale],@"Original","Polygon Size"@);
    ctlposition(c[st_scale],30,base+25);
	c[st_scadj] = ctlpercent("Scale Adj.",myset[st_scadj]);
    ctlposition(c[st_scadj],9,base+50);
    c[st_scvar] = ctlpercent("Vary Scale",myset[st_scvar]);
    ctlposition(c[st_scvar],6,base+75);

	c[st_poslx] = ctldistance("Pos. vary X",myset[st_poslx]);
	c[st_posly] = ctldistance("Y",myset[st_posly]);
	c[st_poslz] = ctldistance("Z",myset[st_poslz]);
    base=280;
	ctlposition(c[st_poslx],3,base);
    ctlposition(c[st_posly],154,base);
    ctlposition(c[st_poslz],260,base);

	c[st_rotlx] = ctlminislider("Rot. vary X",myset[st_rotlx],0,180);
	c[st_rotly] = ctlminislider("Y",myset[st_rotly],0,180);
	c[st_rotlz] = ctlminislider("Z",myset[st_rotlz],0,180);
    base=305;
	ctlposition(c[st_rotlx],4,base);
    ctlposition(c[st_rotly],154,base);
    ctlposition(c[st_rotlz],260,base);

	c[st_pivot] = ctlchoice("Pivot",myset[st_pivot],@"Base","Centre"@);
	c[st_chanc] = ctlpercent("Chance %",myset[st_chanc]);
	c[st_droop] = ctlangle("Droop ",myset[st_droop]);
    base=330;
	ctlposition(c[st_pivot],33,base);
    ctlposition(c[st_chanc],9,base+25);
    ctlposition(c[st_droop],204,base+25);
	t1 = ctltext("Note:","LW 8.5 or earlier users will lose all undo buffers");
    ctlposition(t1,10,380);

	ctlactive(c[st_clone],"LayerActive",c[st_layer]);
	ctlactive(c[st_posit],"PolyActive",c[st_scale]);
	ctlactive(c[st_posit],"CloneActive",c[st_array],c[st_copyx],c[st_copyy],c[st_copyz]);
//	ctlactive(c[st_posit],"YZActive",c[st_copyy],c[st_copyz]);

    return if !reqpost();

    // get requester control values here

	for(i=1;i<=c.size();i++)
	{
		myset[i]=getvalue(c[i]);
		store("MGUltimateClone"+i.asStr(),myset[i]);
	}

    reqend();


	UltimateClone(myset);
    // processing code goes here

}

LayerActive:value
{
	return(value == 3);
}

PolyActive:value
{
	return(value == 2);
}

CloneActive:value
{
	return(value == 3 || value == 4);
}

//YZActive:value { return(value == 3);}

UltimateClone:pset
{

	oldlayers=lyrfg();
	clonelayers=GetCloneLayers();

	selmode(USER);
	editbegin();
	mypoints=points;
	mypolys=polygons;
	if(mypoints==nil || (mypolys==nil && pset[st_posit]==2))
	{
		error("Please select some polygons or points");
		return;
	}

	if(pset[st_posit]==1) // clone to points;
		data=CloneToPoints(mypoints);
	else        // clone to polys
		data=CloneToPolys(mypolys);
	editend();

	if(hostVersion()>=9)
        undogroupbegin();

    myworking=CloneItems(pset,data,clonelayers);
    if(!myworking)
    {
		undogroupend();
		undo();
		lyrsetfg(oldlayers);
		lyrsetbg(clonelayers);
		return;
	}
	RelocateClones(pset,oldlayers,clonelayers,myworking);

    if(hostVersion()>=9)
		undogroupend();
//    info("Done");
}

GetCloneLayers
{
	bkglayers=lyrbg();
	fulllayers=lyrdata();
	clonelayers[1]=nil;
	index=1;
	for(i=1;i<=bkglayers.size();i++)
	{
		if(fulllayers.contains(bkglayers[i]))
		{
			clonelayers[index]=bkglayers[i];
			index++;
		}
	}
	if(clonelayers[1]==nil)
	{
		error("Please select some items to be cloned in the background layers");
	}
	return(clonelayers);
}

CloneToPoints:ppoints
{
	index=1;
    foreach(p,ppoints)
    {
		mypos=pointinfo(p);
		mypointpolys=p.polygon();
		mydir=<0,0,0>;
		for(i=1;i<=p.polygon;i++)
		{
			mydir=mydir+polynormal(mypointpolys[i]);
			mypointpolys[i]=nil;
		}
		mypointpolys[1]=1;
		mypointpolys.trunc();
		mydir=normalize(mydir/(i- 1));
		if(mydir==<0,0,0>)
			mydir=<0,1,0>;

		data[index][st_pos]=mypos;
		data[index][st_dir]=mydir;
		data[index][st_size]=1;
		index++;
	}
	return(data);
}

CloneToPolys:ppolys
{
	index=1;
	foreach(p,ppolys)
	{
		if(!p.isCurve() && p.pointCount>=3)
		{
			mydir=polynormal(p);
			if(mydir==<0,0,0>)
				mydir=<0,1,0>;

			mypos=<0,0,0>;

			firstpoint=p.points[1];

			mymin=pointinfo(firstpoint);
			mymax=pointinfo(firstpoint);

			for(i=1;i<=p.pointCount;i++)
			{
				mypoint=p.points[i];
				mypos=mypos+pointinfo(mypoint);
				mymin=<min(mymin.x,mypos.x),min(mymin.y,mypos.y),min(mymin.z,mypos.z)>;
				mymax=<max(mymax.x,mypos.x),max(mymax.y,mypos.y),max(mymax.z,mypos.z)>;
			}
			mysize=(mymax.x-mymin.x+mymax.y-mymin.y+mymax.z-mymin.z)/3;
			mypos=mypos/(i- 1);

			data[index][st_pos]=mypos;
			data[index][st_dir]=mydir;
			data[index][st_size]=mysize;
			index++;
		}
	}
		return(data);
}

CloneItems:pset,pdata,pclonelayers
{
	myempty=lyrempty();
	myworking=myempty[1];
	mycover=pset[st_chanc];
	moninit(pdata.size(), "Processing");
	for(i=1;i<=pdata.size();i++)
	{
		if(monstep())
			return(0);
		myrand=randu();
		if(myrand<=mycover)
			CloneItem(pdata[i],pset,pclonelayers,myworking);
	}
	monend();
	return(myworking);
}

RelocateClones:pset,pold,pbkg,pworking
{
	lyrsetfg(pworking);
	selunhide();
	if(pset[st_clone]==1)
	{
		cut();
		lyrsetfg(pold);
		paste();
		lyrsetbg(pbkg);
	}
	else if(pset[st_clone]==3)
	{
		cut();
		lyrsetfg(pset[st_layer]);
		paste();
		lyrsetfg(pold);
		lyrsetbg(pset[st_layer]);
	}
	else 
	{
		lyrsetfg(pold);
		lyrsetbg(pworking);
	}
}

CloneItem: pdata,pset,pclonelayers,pworking
{
	myoldfg=lyrfg();

	mylyrch=pset[1];
	mylayer=pset[2];
	myposch=pset[3];
	mydirch=pset[4];
	myscale=pset[5];
	myvaria=pset[6];
	myrotlx=pset[7];
	myrotly=pset[8];
	myrotlz=pset[9];
	mypivot=pset[10];
	mycover=pset[11];
	myscadj=pset[12];

	ppos=pdata[st_pos];
	pvec=pdata[st_dir];
	psize=pdata[st_size];

	// choose clone
	clonelayer=1;
	if(pclonelayers.size()>1)
		clonelayer=random(1,pclonelayers.size());
	lyrsetfg(pclonelayers[clonelayer]);

	// copy to work layer.
	copy();
	lyrsetfg(pworking);
	paste();

	//set centre;
	if(pset[st_pivot]==2)
	{
		mybb=boundingbox();
		myoffset=(mybb[2].y+mybb[1].y)/2;
		move(<0,-myoffset,0>);
	}
	mycentre=<0,0,0>;

	//Scale
	if(pset[st_posit]==2 && pset[st_scale]==2)
	{
		mybb=boundingbox();
		mysize=(mybb[2].x-mybb[1].x+mybb[2].y-mybb[1].y)/2;
		scale(<psize/mysize,psize/mysize,psize/mysize>);
	}
	scale(<pset[st_scadj],pset[st_scadj],pset[st_scadj]>,mycentre);
	
	//scale variance
	scalefactor=1-(randu()*pset[st_scvar]*2-pset[st_scvar]);
	scale(<scalefactor,scalefactor,scalefactor>,mycentre);

	//Random position
	move(<randu()*pset[st_poslx], randu()*pset[st_posly], randu()*pset[st_poslz]>);
	mybb=boundingbox();
	mycentre= <(mybb[1].x+mybb[2].x)/2, 0, (mybb[1].z+mybb[2].z)/2>;

	// rotate variance
	rotxfac=random(1.0 - pset[st_rotlx], pset[st_rotlx]);
	rotyfac=random(1.0 - pset[st_rotly], pset[st_rotly]);
	rotzfac=random(1.0 - pset[st_rotlz], pset[st_rotlz]);
	rotate(rotxfac,X,mycentre);
	rotate(rotyfac,Y,mycentre);
	rotate(rotzfac,Z,mycentre);

	// rotate to dirch
		 if(pset[st_point]==1) pvec=<1,0,0>;        	//+X
	else if(pset[st_point]==2) pvec=<0,1,0>;       		//+Z
	else if(pset[st_point]==3) pvec=<0,0,1>;       		//+Z
	else if(pset[st_point]==4) pvec=<-1,0,0>;      		//-X
	else if(pset[st_point]==5) pvec=<0,-1,0>;      		//-Y
	else if(pset[st_point]==6) pvec=<0,0,-1>;      		//-Z

	// normal
	rot=CalculateRotFromNormal(pvec);
	heading=rot[1];
	pitch=rot[2];

 	//droop
    autoflex(Y,"+","i");
    rotate(-90,Y);
	bend(pset[st_droop]*abs(sin(rad(pitch))),0);
    rotate(90,Y);

	rotate(pitch,X);
	rotate(heading,Y);

	//move to position
	move(ppos);

	//hide
	selhide();
	lyrsetfg(myoldfg);

}

CalculateRotFromNormal:pvec
{
	heading=0;
	pitch=0;
	if(pvec.z!=0)
		heading=deg(atan(pvec.x/pvec.z));
	else
	{
		if(pvec.x>0)
			heading=90;
		else if(pvec.x<0)
			heading=-90;
	}
	if(pvec.z<0)
		heading = 180 + heading;
		
	heading=0-heading;


	outval=pvec.x^^2+pvec.z^^2;
	if(pvec.y==0)
		pitch=90;
	else if(outval!=0)
		pitch=deg(atan(sqrt(outval)/pvec.y));
	else if(pvec.y<0)
		pitch=180;

	if(pitch<0)
		pitch=180+pitch;

	pitch=0-pitch;

	return(heading,pitch);
}